import datetime


def set_date(date):
    CurrentDate.set_date(date)

class CurrentDate:

    value = None


    _datetime = None

    @classmethod
    def now(cls, tz=None):
        return cls.value or datetime.datetime.now(tz)
    @classmethod
    def today(cls):
        return cls.value.date() if cls.value else datetime.date.today()

    @classmethod
    def set_value(cls, date):
        return cls.set_date(date)

    @classmethod
    def set_date(cls, date):

        if isinstance(date, str):
            _datetime = datetime.datetime.strptime(date, "%d/%m/%y")


        class _date_(datetime.date):
            @classmethod
            def today(cls):
                return _datetime.date()

        class _datetime_(datetime.datetime):
            @classmethod
            def now(cls, tz=None):
                return _datetime

        old_dt = datetime.datetime.origin if hasattr(datetime.datetime, "origin") else datetime.datetime
        old_d = datetime.date.origin if hasattr(datetime.date, "origin") else datetime.date

        datetime.datetime = _datetime_
        datetime.datetime.origin = old_dt

        datetime.date = _date_
        datetime.date.origin = old_d