from django.urls import path

from djangotools.view.auto_path import AutoPathManager
from djangotools.view.router import Router
from django.contrib import admin

class RouterIterator:

    def __init__(self):
        self._cache = None

    def __iter__(self):
        if not self._cache:
            print("loaded")
            self._cache= [path('admin/', admin.site.urls)] + AutoPathManager.get_instance().get_pathes() + Router.get_pathes()
        return iter(self._cache)


urlpatterns = RouterIterator()